package xyz.fzorb.noThankYouMicrosoft.flagFrontend;

import net.kyori.adventure.text.minimessage.MiniMessage;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import xyz.fzorb.noThankYouMicrosoft.NoThankYouMicrosoft;

import java.util.*;

public class prideMenu {

    public static final Map<UUID, Inventory> prideMenus = new HashMap<>();

    public static Integer calculateRows(Integer number) {
        if (number <= 9) { return 9; }
        else if (number <= 18) { return 18; }
        else if (number <= 27) { return 27; }
        else if (number <= 36) { return 36; }
        else if (number <= 45) { return 45; }
        else if (number <= 54) { return 54; }
        return 0; // this can NEVER be the case, can it? who am I kidding, I DOUBT there will ever be more than 54 flags!
    }

    public static ItemStack generatePrideItem(String pride) {
        ItemStack is = new ItemStack(Material.PAPER, 1);
        ItemMeta im = is.getItemMeta();
        im.displayName(MiniMessage.miniMessage().deserialize("<pride:" + pride + ">" + pride + "</pride>"));
        is.setItemMeta(im);
        return is;
    }

    public static ItemStack generateNoPrideItem() {
        ItemStack is = new ItemStack(Material.BARRIER, 1);
        ItemMeta im = is.getItemMeta();
        im.displayName(MiniMessage.miniMessage().deserialize("<red>none</red>"));
        is.setItemMeta(im);
        return is;
    }

    public static Inventory generatePrideMenu() {
        List<String> prides = NoThankYouMicrosoft.getInstance().getConfig().getStringList("prides");
        Inventory inventory = Bukkit.createInventory(null, calculateRows(prides.toArray().length + 1), MiniMessage.miniMessage().deserialize("<pride>Choose your flag</pride>"));
        for (String pride : prides) {
            inventory.addItem(generatePrideItem(pride));
        }
        inventory.addItem(generateNoPrideItem());
        return inventory;
    }
}
